# Cmput 455 sample code
# Alphabeta algorithm with trace
# Written by Martin Mueller

from search_basics import INFINITY

SPACES_PER_DEPTH = 4
def indent(depth): return ' ' * (SPACES_PER_DEPTH * depth)

def alphabeta(state, alpha, beta, depth):
    print("{}Call alphabeta with window {} {}"
          .format(indent(depth), alpha, beta))
    if state.endOfGame():
        v = state.staticallyEvaluateForToPlay() 
        print("{}Leaf node value {}".format(indent(depth), v))
        return v
    for m in state.legalMoves():
        print("{}play {}".format(indent(depth), m))
        state.play(m)
        value = -alphabeta(state, -beta, -alpha, depth + 1)
        if value > alpha:
            print("{}New best value {}".format(indent(depth), value))
            alpha = value
        print("{}undo {}".format(indent(depth), m))
        state.undoMove()
        if value >= beta: 
            print("{}beta cut {} >= {}, return {}"
                  .format(indent(depth), value, beta, beta))
            return beta   # or value in failsoft (later)
    print("{}tried all moves, return best value {}"
          .format(indent(depth), alpha))
    return alpha

# initial call with full window
def callAlphabeta(rootState):
    return alphabeta(rootState, -INFINITY, INFINITY, 0)
